
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   14:15:11 05/16/2006
-- Design Name:   HTR_LSB
-- Module Name:   HTR_SLB_tb.vhd
-- Project Name:  HTR_SLB
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: HTR_LSB
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY HTR_SLB_tb_vhd IS
END HTR_SLB_tb_vhd;

ARCHITECTURE behavior OF HTR_SLB_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT HTR_SLB
	PORT(
		TP_a : IN std_logic_vector(35 downto 0);
		TP_b : IN std_logic_vector(35 downto 0);
		loc_add : IN std_logic_vector(6 downto 0);
		loc_rw : IN std_logic;
		loc_cs : IN std_logic;
		loc_spare : IN std_logic_vector(7 downto 0);
		ttc_brcst : IN std_logic_vector(7 downto 2);
		ttc_brcst_strb : IN std_logic;
		ttc_clk_des : IN std_logic;
		ttc_bcr : IN std_logic;
		rx_bc0_p : IN std_logic;
		rx_bc0_n : IN std_logic;
		rx_clk_p : IN std_logic;
		rx_clk_n : IN std_logic;
		GOL_ready : IN std_logic_vector(2 downto 0);
		QPLL_locked : IN std_logic;
		QPLL_err : IN std_logic;    
		loc_bus : INOUT std_logic_vector(7 downto 0);
		GOL_SDA : INOUT std_logic;      
		loc_ctrl : OUT std_logic_vector(2 downto 0);
		GOL0_data : OUT std_logic_vector(31 downto 0);
		GOL1_data : OUT std_logic_vector(31 downto 0);
		GOL2_data : OUT std_logic_vector(31 downto 0);
		GOL0_flag : OUT std_logic_vector(1 downto 0);
		GOL1_flag : OUT std_logic_vector(1 downto 0);
		GOL2_flag : OUT std_logic_vector(1 downto 0);
		GOL_reset_b : OUT std_logic_vector(2 downto 0);
		GOL_negedge : OUT std_logic;
		GOL_cav : OUT std_logic_vector(2 downto 0);
		GOL_dav : OUT std_logic_vector(2 downto 0);
		GOL_FF : OUT std_logic_vector(2 downto 0);
		GOL_SCL : OUT std_logic_vector(2 downto 0);
		rst_QPLL : OUT std_logic;
		CB_SI : OUT std_logic;
		CB_EN : OUT std_logic;
		CB_CK : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL loc_rw :  std_logic := '0';
	SIGNAL loc_cs :  std_logic := '1';
	SIGNAL ttc_brcst_strb :  std_logic := '0';
	SIGNAL ttc_clk_des :  std_logic := '0';
	SIGNAL ttc_bcr :  std_logic := '0';
	SIGNAL rx_bc0_p :  std_logic := '0';
	SIGNAL rx_bc0_n :  std_logic := '0';
	SIGNAL rx_clk_p :  std_logic := '0';
	SIGNAL rx_clk_n :  std_logic := '0';
	SIGNAL QPLL_locked :  std_logic := '0';
	SIGNAL QPLL_err :  std_logic := '0';
	SIGNAL TP_a :  std_logic_vector(35 downto 0) := (others=>'0');
	SIGNAL TP_b :  std_logic_vector(35 downto 0) := (others=>'0');
	SIGNAL loc_add :  std_logic_vector(6 downto 0) := "0011000";
	SIGNAL loc_spare :  std_logic_vector(7 downto 0) := "00100000";
	SIGNAL ttc_brcst :  std_logic_vector(7 downto 2) := (others=>'0');
	SIGNAL GOL_ready :  std_logic_vector(2 downto 0) := (others=>'0');

	--BiDirs
	SIGNAL loc_bus :  std_logic_vector(7 downto 0);
	SIGNAL GOL_SDA :  std_logic;

	--Outputs
	SIGNAL loc_ctrl :  std_logic_vector(2 downto 0);
	SIGNAL GOL0_data :  std_logic_vector(31 downto 0);
	SIGNAL GOL1_data :  std_logic_vector(31 downto 0);
	SIGNAL GOL2_data :  std_logic_vector(31 downto 0);
	SIGNAL GOL0_flag :  std_logic_vector(1 downto 0);
	SIGNAL GOL1_flag :  std_logic_vector(1 downto 0);
	SIGNAL GOL2_flag :  std_logic_vector(1 downto 0);
	SIGNAL GOL_reset_b :  std_logic_vector(2 downto 0);
	SIGNAL GOL_negedge :  std_logic;
	SIGNAL GOL_cav :  std_logic_vector(2 downto 0);
	SIGNAL GOL_dav :  std_logic_vector(2 downto 0);
	SIGNAL GOL_FF :  std_logic_vector(2 downto 0);
	SIGNAL GOL_SCL :  std_logic_vector(2 downto 0);
	SIGNAL rst_QPLL :  std_logic;
	SIGNAL CB_SI :  std_logic;
	SIGNAL CB_EN :  std_logic;
	SIGNAL CB_CK :  std_logic;
	SIGNAL clock :  std_logic := '0';
	SIGNAL counter :  std_logic_vector(15 downto 0) := x"7ff0";

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: HTR_SLB PORT MAP(
		TP_a => TP_a,
		TP_b => TP_b,
		loc_bus => loc_bus,
		loc_add => loc_add,
		loc_rw => loc_rw,
		loc_cs => loc_cs,
		loc_ctrl => loc_ctrl,
		loc_spare => loc_spare,
		ttc_brcst => ttc_brcst,
		ttc_brcst_strb => ttc_brcst_strb,
		ttc_clk_des => ttc_clk_des,
		ttc_bcr => ttc_bcr,
		rx_bc0_p => rx_bc0_p,
		rx_bc0_n => rx_bc0_n,
		rx_clk_p => rx_clk_p,
		rx_clk_n => rx_clk_n,
		GOL_ready => GOL_ready,
		GOL0_data => GOL0_data,
		GOL1_data => GOL1_data,
		GOL2_data => GOL2_data,
		GOL0_flag => GOL0_flag,
		GOL1_flag => GOL1_flag,
		GOL2_flag => GOL2_flag,
		GOL_reset_b => GOL_reset_b,
		GOL_negedge => GOL_negedge,
		GOL_cav => GOL_cav,
		GOL_dav => GOL_dav,
		GOL_FF => GOL_FF,
		GOL_SCL => GOL_SCL,
		GOL_SDA => GOL_SDA,
		QPLL_locked => QPLL_locked,
		QPLL_err => QPLL_err,
		rst_QPLL => rst_QPLL,
		CB_SI => CB_SI,
		CB_EN => CB_EN,
		CB_CK => CB_CK
	);
	ttc_clk_des <= not ttc_clk_des after 10ns;
	loc_bus <= x"80";
	clock <= not clock after 15 ns;
--	loc_bus <= counter(7 downto 1) & '1' when counter < x"8204" else (others => 'Z');
	process(clock)
	begin
	  if(clock'event and clock = '1')then
	    counter <= counter + 1;
	  end if;
	  if(counter(15) = '1' and counter < x"8204")then
	    loc_cs <= counter(0);
--	    loc_spare(5) <= counter(0);
		 if(counter = x"8201")then
		   loc_add <= "1100010";
		 elsif(counter(1) = '1')then
		   loc_add(0) <= '1';
		 end if;
	  end if;
	end process;
	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;
		loc_spare(5) <= '0';
      wait for 100 ns;
		loc_spare(5) <= '1';
		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
